// Displacement mapping example
// "Heavy Metal Teapot"

// Not totally correct. I get cracks, most likely due to an incorrect "zero"

#define MAIN
#include <stdio.h>
#include "MicroGlut.h"
#include "GL_utilities.h"
#include "VectorUtils4.h"
#include "LoadTGA.h"
#include "LittleOBJLoader.h"
// uses framework Cocoa
// uses framework OpenGL

// vertex array object
unsigned int vertexArrayObjID;
// Reference to shader program
GLuint shader;

// Tesselation control variables
GLint TessLevelInner = 2;
GLint TessLevelOuter1 = 2;
GLint TessLevelOuter2 = 2;
GLint TessLevelOuter3 = 2;
Model *bunny;
GLuint tex;

void ReportRerror(const char*s1, const char*s2)
{
	printf("%s %s\n", s1, s2);
}

void init(void)
{
	// two vertex buffer objects, used for uploading the
	unsigned int vertexBufferObjID;
	unsigned int colorBufferObjID;

	dumpInfo();

	// GL inits
	glClearColor(0.2,0.2,0.5,0);

	glEnable(GL_DEPTH_TEST);

	// Load and compile shader
	shader = loadShadersGT("minimal.vs", "minimal.fs", "minimal.gs",
							"minimal.tcs", "minimal.tes");

	glUniform1i(glGetUniformLocation(shader, "TessLevelInner"), TessLevelInner);
	glUniform1i(glGetUniformLocation(shader, "TessLevelOuter1"), TessLevelOuter1);
	glUniform1i(glGetUniformLocation(shader, "TessLevelOuter2"), TessLevelOuter2);
	glUniform1i(glGetUniformLocation(shader, "TessLevelOuter3"), TessLevelOuter3);
	
	// Upload geometry to the GPU:
	
//	bunny = LoadModel("bunnyplus.obj");
	bunny = LoadModel("teapotx.obj");

// Texture unit 0
	glActiveTexture(GL_TEXTURE0);
	LoadTGATextureSimple("spots.tga", &tex);
	glUniform1i(glGetUniformLocation(shader, "tex"), 0); // Texture unit 0
	
	// Wireframe please!
	glPolygonMode(GL_FRONT, GL_LINE);
	glPolygonMode(GL_BACK, GL_LINE);
}

// Same as DrawModel but with GL_PATCHES
void DrawPatchModel(Model *m, GLuint program, const char* vertexVariableName, const char* normalVariableName, const char* texCoordVariableName)
{
    #ifndef GL_PATCHES
        #define GL_PATCHES 0x0000000e
    #endif

	if (m != NULL)
	{
		GLint loc;
		
		glPatchParameteri(GL_PATCH_VERTICES, 3);
		glBindVertexArray(m->vao);	// Select VAO

		glBindBuffer(GL_ARRAY_BUFFER, m->vb);
		loc = glGetAttribLocation(program, vertexVariableName);
		if (loc >= 0)
		{
			glVertexAttribPointer(loc, 3, GL_FLOAT, GL_FALSE, 0, 0); 
			glEnableVertexAttribArray(loc);
		}
		else
			ReportRerror("DrawModel", vertexVariableName);
		
		if (normalVariableName!=NULL)
		{
			loc = glGetAttribLocation(program, normalVariableName);
			if (loc >= 0)
			{
				glBindBuffer(GL_ARRAY_BUFFER, m->nb);
				glVertexAttribPointer(loc, 3, GL_FLOAT, GL_FALSE, 0, 0);
				glEnableVertexAttribArray(loc);
			}
			else
				ReportRerror("DrawModel", normalVariableName);
		}
	
		// VBO for texture coordinate data NEW for 5b
		if ((m->texCoordArray != NULL)&&(texCoordVariableName != NULL))
		{
			loc = glGetAttribLocation(program, texCoordVariableName);
			if (loc >= 0)
			{
				glBindBuffer(GL_ARRAY_BUFFER, m->tb);
				glVertexAttribPointer(loc, 2, GL_FLOAT, GL_FALSE, 0, 0);
				glEnableVertexAttribArray(loc);
			}
			else
				ReportRerror("DrawModel", texCoordVariableName);
		}

		glDrawElements(GL_PATCHES, m->numIndices, GL_UNSIGNED_INT, 0L);
	}
}

float a = 0.0;
char anim = 0;

float disp;
int texon = 0;

void display(void)
{
	mat4 m;
	if (anim)
		a += 0.1;
	
	printError("pre display");

	// clear the screen
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glUseProgram(shader);
		
	glPatchParameteri(GL_PATCH_DEFAULT_OUTER_LEVEL, 3);
	glPatchParameteri(GL_PATCH_DEFAULT_INNER_LEVEL, 3);

	glUniform1f(glGetUniformLocation(shader, "disp"), disp);
	glUniform1i(glGetUniformLocation(shader, "texon"), texon);
	
	mat4 projectionMatrix = frustum(-0.5, 0.5, -0.5, 0.5, 1.0, 30.0);
	mat4 worldToViewMatrix = lookAt(0, 1, 3, 0,0,0, 0,1,0);
	mat4 modelToWorldMatrix = Ry(a);

	m = projectionMatrix * worldToViewMatrix * modelToWorldMatrix;
	glUniformMatrix4fv(glGetUniformLocation(shader, "m"), 1, GL_TRUE, m.m);
	
	DrawPatchModel(bunny, shader, "in_Position", "in_Normal", "in_TexCoord");

	glutSwapBuffers();
}

void key(unsigned char key, int x, int y)
{
	glUseProgram(shader);

	if (key == 't')
		texon = (texon + 1) % 3;
	if (key == 'a')
		disp += 0.05;
	if (key == 'z')
		disp -= 0.05;


	if (key == '+')
		TessLevelInner++;
	if (key == '-')
		if (TessLevelInner > 1)
			TessLevelInner--;
	if (key == '.')
	{
		TessLevelOuter1++;
		TessLevelOuter2++;
		TessLevelOuter3++;
	}
	if (key == ',')
	{
		if (TessLevelOuter1 > 1)
			TessLevelOuter1--;
		if (TessLevelOuter2 > 1)
			TessLevelOuter2--;
		if (TessLevelOuter3 > 1)
			TessLevelOuter3--;
	}

	if (key == '2')
		TessLevelOuter1++;
	if (key == '1')
		if (TessLevelOuter1 > 1)
			TessLevelOuter1--;
	if (key == '4')
		TessLevelOuter2++;
	if (key == '3')
		if (TessLevelOuter2 > 1)
			TessLevelOuter2--;
	if (key == '6')
		TessLevelOuter3++;
	if (key == '5')
		if (TessLevelOuter3 > 1)
			TessLevelOuter3--;
	if (key == ' ')
		anim = !anim;

	printf("TessLevelInner = %d TessLevelOuter1 = %d TessLevelOuter2 = %d TessLevelOuter3 = %d\n", TessLevelInner, TessLevelOuter1, TessLevelOuter2, TessLevelOuter3);
	glUniform1i(glGetUniformLocation(shader, "TessLevelInner"), TessLevelInner);
	glUniform1i(glGetUniformLocation(shader, "TessLevelOuter1"), TessLevelOuter1);
	glUniform1i(glGetUniformLocation(shader, "TessLevelOuter2"), TessLevelOuter2);
	glUniform1i(glGetUniformLocation(shader, "TessLevelOuter3"), TessLevelOuter3);
	glutPostRedisplay();
}

void reshape(int x, int y)
{
	glViewport(0,0,x,y);
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitContextVersion(4, 1); // OK for GL 4 as well on Mac...
	glutCreateWindow ("GL4 tesselation example +-,.123456 azt");
	glutDisplayFunc(display);
	glutRepeatingTimer(20);
	glutReshapeFunc(reshape);
	glutKeyboardFunc(key);
	init ();
	glutMainLoop();
}

